package com.deplay.one.hybrid.canvas.common

import android.content.Context
import java.lang.reflect.Field

object CanvasConfig {
    var screenWidth = 0
    var screenHeight = 0
    var screenMin // 宽高中，较小的值
            = 0
    var screenMax // 宽高中，较大的值
            = 0
    var density = 0f
    var scaleDensity = 0f
    var xdpi = 0f
    var ydpi = 0f
    var densityDpi = 0
    var dialogWidth = 0
    var statusbarheight = 0
    var navbarheight = 0
    var sbarHeight = 0
    private const val RATIO = 0.85
    fun init(context: Context?) {
        if (null == context) {
            return
        }
        val dm = context.applicationContext.resources.displayMetrics
        screenWidth = dm.widthPixels
        screenHeight = dm.heightPixels
        screenMin = if (screenWidth > screenHeight) screenHeight else screenWidth
        screenMax = if (screenWidth < screenHeight) screenHeight else screenWidth
        density = dm.density
        scaleDensity = dm.scaledDensity
        xdpi = dm.xdpi
        ydpi = dm.ydpi
        densityDpi = dm.densityDpi
        statusbarheight = getStatusBarHeight(context)
        navbarheight = getNavBarHeight(context)
    }

    fun getStatusBarHeight(context: Context): Int {
        if (sbarHeight > 0) return sbarHeight
        var c: Class<*>? = null
        var obj: Any? = null
        var field: Field? = null
        try {
            c = Class.forName("com.android.internal.R\$dimen")
            obj = c.newInstance()
            field = c.getField("status_bar_height")
            val x = field[obj].toString().toInt()
            sbarHeight = context.resources.getDimensionPixelSize(x)
        } catch (E: Exception) {
            E.printStackTrace()
        }
        return sbarHeight
    }

    fun getNavBarHeight(context: Context): Int {
        val resources = context.resources
        val resourceId = resources.getIdentifier("navigation_bar_height", "dimen", "android")
        return if (resourceId > 0) {
            resources.getDimensionPixelSize(resourceId)
        } else 0
    }
}