package com.deplay.one.hybrid.canvas.common

import android.util.Log
import com.eclipsesource.v8.JavaVoidCallback
import com.eclipsesource.v8.Releasable
import com.eclipsesource.v8.V8


/**
 * Created by lht on 16/9/20.
 */
object CanvasJSCore {
    const val LOG_TAG = "ColorBoxJSCore"
    private lateinit var mRuntime: V8
    // var mRuntime: V8? = null
    @JvmStatic
    fun getRuntime(): V8{
        mRuntime = V8.createV8Runtime()
        mRuntime.registerJavaMethod(JavaVoidCallback { receiver, parameters ->
            if (parameters.length() > 0) {
                val msg = parameters[0]
                Log.d(LOG_TAG, msg.toString())
                if (msg is Releasable) {
                    msg.release()
                }
            }
        }, "log")
        mRuntime.add("screenWidth", CanvasConfig.screenWidth)
        mRuntime.add("screenHeight", CanvasConfig.screenHeight - CanvasConfig.navbarheight - CanvasConfig.statusbarheight)

        return mRuntime
    }

    @JvmStatic
    fun run(js: String?) {
        mRuntime.executeScript(js)
    }

    @JvmStatic
    fun runJSWithRuntime(js:String,runtime:V8){
        runtime.executeScript(js);
    }

    @JvmStatic
    fun clean(canvasObj: CanvasV8Object) {
        canvasObj.clean()
        mRuntime.release()
    }
}