package com.deplay.one.hybrid.canvas.common

import android.graphics.Color;
import android.graphics.Paint;

class CloneablePaint : Paint {
    constructor() {}
    constructor(paint: CloneablePaint?) : super(paint) {}

    /**
     * 设置颜色,Paint.setColor()后会重置Alpha为255
     *
     * @param color "#ffffff"
     */
    fun setRgbColor(color: String) {
        val alpha = alpha
        setColor(rgb(color))
        setAlpha(alpha)
    }

    /**
     * Converts the given hex-color-string to rgb.
     *
     * @param hex
     * @return
     */
    private fun rgb(hex: String): Int {
        val color = hex.replace("#", "").toLong(16).toInt()
        val r = color shr 16 and 0xFF
        val g = color shr 8 and 0xFF
        val b = color shr 0 and 0xFF
        return Color.rgb(r, g, b)
    }
}