package com.deplay.one.hybrid.canvas.view

import android.content.Context
import android.graphics.Bitmap
import android.graphics.Canvas
import android.graphics.Paint
import android.util.AttributeSet
import android.view.View
import com.deplay.one.hybrid.canvas.common.CanvasConfig
import com.deplay.one.hybrid.canvas.draw.AbstractDraw
import com.eclipsesource.v8.V8
import com.eclipsesource.v8.V8Object
import java.io.Serializable
import java.util.*


class CanvasView : View, Serializable {
    var mContext: Context
    var canvasWidth: Float = CanvasConfig.screenWidth.toFloat()
    var canvasHeight: Float = CanvasConfig.screenHeight.toFloat() - CanvasConfig.navbarheight.toFloat()- CanvasConfig.statusbarheight.toFloat()
    var canvasX = 0f
    var canvasY = 0f
    lateinit var mBitmap: Bitmap
    var bDrawFinished = false

    constructor(context: Context) : super(context) {
        mContext = context
    }

    constructor(context: Context, attrs: AttributeSet?) : super(context, attrs) {
        mContext = context
    }

    fun draw(abstractDrawList: ArrayList<AbstractDraw>) {
        mBitmap = Bitmap.createBitmap(canvasWidth.toInt(), canvasHeight.toInt(), Bitmap.Config.ARGB_8888)
        val canvas = Canvas()
        canvas.setBitmap(mBitmap)
        for (abstractDraw in abstractDrawList) {
            abstractDraw.draw(canvas)
        }

        bDrawFinished = true
    }

    override fun onDraw(canvas: Canvas) {
        super.onDraw(canvas)
        if (bDrawFinished) {
            canvas.drawBitmap(mBitmap, 0f, 0f, Paint())
            mBitmap!!.recycle()
            bDrawFinished = false
        }
    }

}