package com.deplay.one.hybrid.canvas.view

import android.content.Context
import android.util.AttributeSet
import android.view.ViewGroup


class CanvasViewGroup : ViewGroup {
    var mContext: Context

    constructor(context: Context) : super(context) {
        mContext = context
    }

    constructor(context: Context, attrs: AttributeSet?) : super(context, attrs) {
        mContext = context
    }

    override fun onLayout(changed: Boolean, left: Int, top: Int, right: Int, bottom: Int) {
        val childCount = childCount
        for (i in 0 until childCount) {
            val childView: CanvasView = getChildAt(i) as CanvasView
            val x = childView.canvasX.toInt()
            val y = childView.canvasY.toInt()
            val width = childView.canvasWidth.toInt()
            val height = childView.canvasWidth.toInt()
            childView.layout(x, y, x + width, y + height)
        }
    }
}