package com.deplay.one.hybrid_example


import android.os.Bundle
import android.app.Activity
import android.view.View
import android.widget.TextView
import androidx.annotation.Nullable
import com.deplay.one.hybrid_example.R
import com.deplay.one.hybrid_example.PageRouter
import java.lang.ref.WeakReference
import java.util.*

class MainActivity : Activity(), View.OnClickListener {
    private var mOpenCanvas: TextView? = null
    private var mOpenHybrid: TextView? = null

    protected override fun onCreate(@Nullable savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        sRef = WeakReference(this)
        setContentView(R.layout.native_page)
        mOpenCanvas = findViewById<TextView>(R.id.open_canvas)
        mOpenHybrid = findViewById<TextView>(R.id.open_hybrid)

        mOpenCanvas!!.setOnClickListener(this)
        mOpenHybrid!!.setOnClickListener(this)

    }

    protected override fun onDestroy() {
        super.onDestroy()
        sRef!!.clear()
        sRef = null
    }

    override fun onClick(v: View) {
        val params = HashMap<String, Any?>()
        params.put("test","test1");
        //Add some params if needed.
        if (v === mOpenCanvas) {
            PageRouter.openPageByUrl(this, PageRouter.CANVAS_PAGE_URL, params)
        } else if (v === mOpenHybrid) {
            PageRouter.openPageByUrl(this, PageRouter.HYBRID_PAGE_URL, params)
        }
    }

    companion object {
        var sRef: WeakReference<MainActivity>? = null
    }
}