package com.deplay.one.hybrid_example.activity;

import android.os.Bundle;
import android.os.Handler;
import android.app.Activity;
import android.os.Looper;
import android.util.Log;
import android.view.View;
import android.widget.TextView;

import com.deplay.one.hybrid.v8.V8Manager;
import com.eclipsesource.v8.V8;
import com.deplay.one.hybrid.canvas.common.CanvasJSCore;
import com.deplay.one.hybrid.canvas.view.CanvasViewGroup;
import com.deplay.one.hybrid.canvas.wrapper.CanvasWindow;

import com.deplay.one.hybrid_example.R;
import com.deplay.one.hybrid_example.util.FileUtil;
import com.eclipsesource.v8.V8Object;



class Console {
    public void log(final Object message) {
        System.out.println("[INFO] " + message.toString());
    }
    public void error(final Object message) {
        System.out.println("[ERROR] " +  message.toString());
    }
}

public class CanvasActivity extends Activity {

    long time = 0;
    String js;
    String global;

    TextView mTvMsg;
    CanvasViewGroup mViewGroup;
    CanvasWindow mCanvasWindow;

    int mCount;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setTitle(R.string.title_v8);
        setContentView(R.layout.activity_canvas);

        mCount = getIntent().getIntExtra("count", 1000);

        mViewGroup = (CanvasViewGroup) findViewById(R.id.view_group);
        mTvMsg = (TextView) findViewById(R.id.tv_msg);

        // global=FileUtil.getFromAssets(this, "global.js");
        js = FileUtil.getFromAssets(this, "v8.js");
        // js = js.replace("$count$", mCount + "");
        draw(null);
    }

    public void draw(View v) {
        new Thread(runnable).start();
    }

    private Runnable runnable = new Runnable() {
        @Override
        public void run() {
            Looper.prepare();
            long start = System.currentTimeMillis();


            V8 v8Runtime = CanvasJSCore.getRuntime();
            // V8Object v8Console = new V8Object(v8Runtime);

            v8Runtime.executeVoidScript("var GameGlobal={};var wx={}");

            mCanvasWindow = new CanvasWindow(v8Runtime, mViewGroup);
            // v8Runtime.add("wx", mCanvasWindow.getV8Object());
            v8Runtime.add("window", mCanvasWindow.getV8Object());
//            // CanvasJSCore.run(global);

            v8Runtime.add("console", mCanvasWindow.getV8Object());
            Console console = new Console();
            mCanvasWindow.getV8Object().registerJavaMethod(console, "log", "log", new Class<?>[] { Object.class });
            // mCanvasWindow.getV8Object().registerJavaMethod(console, "err", "err", new Class<?>[] { String.class });
            mCanvasWindow.getV8Object().release();

            CanvasJSCore.run(js);
            mCanvasWindow.drawWindow();


//             CanvasJSCore.clean(mCanvasWindow);

            long end = System.currentTimeMillis();
            time = end - start;
            handler.sendEmptyMessage(0);
            Looper.loop();
        }
    };

    private Handler handler = new Handler() {

        @Override
        public void handleMessage(android.os.Message msg) {

            long start = System.currentTimeMillis();
            mCanvasWindow.invalidate();
            long end = System.currentTimeMillis();
            time += end - start;
            Log.d("EXETIME", time + "");
            mTvMsg.setText(
                    String.format(
                            getResources().getString(R.string.format_time),
                            time + ""));


        }
    };


}
