//
//  JSCoreEngine.m
//  Runner
//
//  Created by 苏玮 on 2019/12/9.
//  Copyright © 2019 The Chromium Authors. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "JSCoreEngine.h"

@interface JSCoreEngine()

@property(nonatomic,strong) NSMutableArray *searchDirArray;
@property(nonatomic,strong) NSMutableSet *runnedScriptFile;

@end

@implementation JSCoreEngine

- (instancetype)init
{
    if (self = [super init])
    {
        self.searchDirArray = [NSMutableArray array];
        self.runnedScriptFile = [[NSMutableSet alloc] init];
        [self setup];
    }

    return self;
}

- (void)dealloc
{
    NSLog(@"dealloc ");
}

- (void)setup
{
    
    self.jsExecutor = [[JSCoreExecutor alloc] init];
    
    __weak JSCoreEngine *weakSelf = self;
    [self.jsExecutor executeJSCBlockOnJSThread:^(JSCoreExecutor *executor) {
        setupBasicJSRuntime(weakSelf,executor.jsContext);
    }];
}

static void setupBasicJSRuntime(JSCoreEngine* jsEngine,  JSContext* context)
{
    
    // __weak JSCoreEngine *weakSelf = jsEngine;
    [context evaluateScript:@"var global = this;"];
    NSString* jsStr = [[NSString alloc] initWithData:[NSData dataWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"framework" ofType:@"js"]] encoding:NSUTF8StringEncoding];
    // jsContext
    // make module exports is workable
    [NSString stringWithFormat:@"(function (){let module = {exports:{}};(function (){\n%@ \n})(); return module.exports;})();" ,jsStr];
    // eval js
    
    [context evaluateScript:jsStr];
    
    [context evaluateScript:@"var console = {}"];
    context[@"console"][@"log"] = ^(NSString *message) {
        NSLog(@"Javascript log: %@",message);
    };
    
    context.exceptionHandler = ^(JSContext *con, JSValue *exception) {
        NSLog(@"js context.exceptionHandler  %@", exception.toObject);
        NSLog(@"js context.exceptionMessage  %@", exception[@"message"]);
        NSLog(@"js context.exceptionStack  %@", exception[@"stack"]);
    };
}


@end
