//
//  JSCoreExecutor.h
//  Runner
//
//  Created by 苏玮 on 2019/12/9.
//  Copyright © 2019 The Chromium Authors. All rights reserved.
//
#import <Foundation/Foundation.h>
#import <JavaScriptCore/JavaScriptCore.h>

@class JSCoreExecutor;

typedef void (^JSCCompleteBlock)(NSError * _Nullable error);
typedef void (^JSCCallback)(id _Nonnull result, NSError * _Nullable error);
typedef void (^JSCValueCallback)(JSValue * _Nullable result, NSError * _Nullable error);
typedef void (^JSCDispatchBlock)(JSCoreExecutor * _Nullable jsExecutor);
NS_ASSUME_NONNULL_BEGIN


@interface JSCoreExecutor : NSObject;

@property (nonatomic, readonly) BOOL isValid;

- (JSContext *)jsContext;

- (void)executeScriptAsync:(NSString *)script
                 sourceURL:(NSURL *)sourceURL
                onComplete:(JSCCompleteBlock )onComplete;

//- (void)executeScriptPath:(NSString*)path
//               onComplete:(JSCCompleteBlock )onComplete;

- (JSValue *)executeJS:(NSString *)script;
- (JSValue *)executeScript:(NSString *)script  sourceURL:(NSURL *)sourceURL;


//- (void)callFunctionOnModule:(NSString *)module
//                      method:(NSString *)method
//                   arguments:(NSArray *)args
//             jsValueCallback:(DPOJavaScriptValueCallback)onComplete;


- (void)executeJSCBlockOnJSThread:(JSCDispatchBlock)block;

- (void)executeBlockOnJSThread:(dispatch_block_t)block;

- (void)invokeJSValue:(JSValue *)jsValue mothod:(NSString *)method args:(NSArray *)args callback:(JSCValueCallback )callback;

- (void)invokeMothod:(NSString *)method args:(NSArray *)args callback:(JSCValueCallback )callback;

@end
NS_ASSUME_NONNULL_END
