//
//  JSCorePageManager.h
//  Runner
//
//  Created by 苏玮 on 2019/12/9.
//  Copyright © 2019 The Chromium Authors. All rights reserved.
//
#import "JSCoreEngine.h"
#import "JSCoreNetwork.h"
#import "EventEmitter.h"

@interface JSCorePageManager: NSObject
- (instancetype _Nonnull )init:(JSCoreEngine*_Nonnull) engine emitter:(NSObject* _Nullable )emitter;
@property(nonatomic,strong) JSCoreEngine * _Nonnull jsCoreEngine;
@property(nonatomic,strong) NSMutableDictionary * _Nonnull pageDictionary;
@property(nonatomic,strong) NSString * _Nonnull currentPageId;
@property(nonatomic,strong) JSCoreNetwork * _Nonnull network;
typedef void (^ContextCallback)(JSValue*_Nullable origin, NSError * _Nullable error);
// @property(nonatomic,strong) NSObject * _Nonnull emitter;
-(void) setJSCoreEngine:(JSCoreEngine*_Nonnull) engine;
-(void) attachPageScriptToJsCore:(NSString*_Nonnull)pageId scriptToAttach:(NSString*_Nonnull)script;
-(void) attachPage:(NSString*_Nonnull)pageId scriptToAttach:(NSString*_Nonnull)script;
-(void) callMethodInPage:(NSString *_Nonnull) pageId method:(NSString *_Nonnull) method varArg:(NSString * _Nullable) args;
-(void) onInitComplete:(NSString*_Nonnull)pageId;
-(JSValue*_Nonnull) handleRepeat:(NSString*_Nonnull)pageId
         componentId:(NSString*_Nonnull)componentId
                type:(NSString*_Nonnull)type
                 key:(NSString*_Nonnull)key
               watch:(NSNumber*_Nonnull)watch
          expression:(NSString*_Nonnull)expression;
-(NSString*_Nonnull) handleExpression:(NSString*_Nonnull)pageId
componentId:(NSString*_Nonnull)componentId
       type:(NSString*_Nonnull)type
        key:(NSString*_Nonnull)key
      watch:(NSNumber*_Nonnull)watch
 expression:(NSString*_Nonnull)expression;
-(void) onRefresh:(NSString*_Nonnull)pageId
             data:(NSString*_Nonnull)data;
-(void) onRemovePage:(NSString*_Nonnull)pageId;
-(void) onRemoveObserver:(NSString*_Nonnull)pageId ids:(NSArray*_Nonnull)ids;
-(JSValue *_Nonnull) getJSPage:(NSString*_Nonnull)pageId;
-(NSString *_Nonnull)dictToJson:(NSDictionary*_Nonnull)dic;
-(NSString *_Nonnull)getUUID;

@end


