import 'package:flutter/material.dart';
import 'package:dva_dart/dva_dart.dart';
import 'package:dva_flutter/provider.dart';

import './pages/hybrid/app.dart';

class Hybrid extends StatelessWidget {
  final DvaStore store;
  final String bundleApiUrl;
  final String indexKey;
  Hybrid({this.store, this.bundleApiUrl, this.indexKey});
  @override
  Widget build(BuildContext context) {
    return DvaProvider<DvaStore>(
      child: MaterialApp(
        routes: {
          '/': (BuildContext context) => HybridApp(bundleApiUrl, indexKey),
          '/warmup': (BuildContext context) => WarmupPage(),
        },
        title: 'Hybrid App Example',
        // home: HybridApp(bundleApiUrl, indexKey)
      ),
      store: store,
    );
  }
}

class WarmupPage extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Center(
      child: Text(
        "warming up!",
        style: TextStyle(color: Colors.white),
      ),
    );
  }
}
