import 'package:dva_dart/dva_dart.dart';
import '../../services/hybrid_http.dart';
import 'state.dart';

DvaModel hybridAppModel = DvaModel(
    // namespace
    nameSpace: 'hybridApp',
    // initialState
    initialState: HybridAppState.init(),
    // reducers
    reducers: {
      'loadJson': (DvaState state, Payload<Map<String, dynamic>> payload) {
        return HybridAppState.loadJson(
            json: payload.payload["json"],
            indexPage: payload.payload["indexPage"]);
      },
    },
// effects
    effects: {
      'getBundle': (Payload<Map<String, String>> payload) async* {
        String bundleApiUrl = payload.payload["bundleApiUrl"];
        String indexKey = payload.payload["indexKey"];

        var result = await getBundle(url: bundleApiUrl);
        yield PutEffect(
            key: 'loadJson',
            payload: Payload<Map<String, dynamic>>(
                {"json": result, "indexPage": indexKey}));
      },
    });
