import 'package:flutter/services.dart';
import 'package:dva_dart/dva_dart.dart';

import 'abstracts.dart';

const String CHANNEL_METHOD = "com.deplay.one.hybrid/method";
const String CHANNEL_BASIC = "com.deplay.one.hybrid/basic";

enum HybridAppStatus { Loading, Success, Error }

class HybridAppState implements DvaState {
  // MethodChannel _methodChannel = MethodChannel(CHANNEL_METHOD);
  BasicMessageChannel<String> _basicChannel =
      BasicMessageChannel<String>(CHANNEL_BASIC, StringCodec());
  MethodChannel _methodChannel = MethodChannel(CHANNEL_METHOD);

  Map<String, String> _pages = Map();
  Map<String, HybridMessageHandler> _handlers = Map();
  String _indexPage;

  Map<String, String> get pages => _pages;
  Map<String, HybridMessageHandler> get handlers => _handlers;
  MethodChannel get methodChannel => _methodChannel;
  BasicMessageChannel<String> get basicChannel => _basicChannel;
  String get indexPage => _indexPage;

  HybridAppStatus status = HybridAppStatus.Loading;

  HybridAppState.init() {
    _basicChannel.send("connected");
    status = HybridAppStatus.Loading;
  }
  HybridAppState.loadJson({Map<String, dynamic> json, String indexPage}) {
    json.forEach((k, v) {
      _pages.putIfAbsent(k, () => v.toString());
    });
    _indexPage = indexPage;
    status = HybridAppStatus.Success;
  }
}
